#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QUrl>
#include <QQmlContext>
#include <QDesktopServices>
#include <QDebug>

class MyURLHandler : public QObject
{
    Q_OBJECT

signals:
    void incomingURL(QString path);
public slots:
    void handleURL(const QUrl &url)
    {
        qDebug() << "this is handleURL function";
        QString str("Hello World");
        emit incomingURL(url.toString());
    }

};

//class MyURLHandler : public QObject
//{
//    Q_OBJECT
//
//public:
//    Q_INVOKABLE QString handleURL()
//    {
//        QString str("Hello World");
//        return str; //url.toString();
//    }
//
//};


int main(int argc, char *argv[])
{
#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
#endif

    QGuiApplication app(argc, argv);

    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));

    MyURLHandler *myHandler = new MyURLHandler();
    QDesktopServices::setUrlHandler("myscheme", myHandler, "handleURL");
    engine.rootContext()->setContextProperty("MyHandler", myHandler);
    
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);


    return app.exec();
}

#include "main.moc"
